#!/bin/bash
#Испозовать только на свой страх и риск!
#Автор не несёт ответственности за последствия работы скрипта. )))
#Скрипт добавляет все библиотеки символов в проект Kikad 7 из каталога Libray и устанавливает их избранными (вложенные каталоги игнорируются).
#Ранее добавленные библиотеки сохраняются, также присутствует защита от дублирующего добавления.
#В процессе работы создаются бекапы изменяемых файлов.
#
#Условия срабатывания:
#
#1. Скрипт использует утилиты jq и sed.
#
#2. Скрипт должен находиться в каталоге проекта
#
#3. Файлы и каталоги проекта, а также добавляемых библиотек не должны иметь в названии пробелов и спецсимволов (нижнее подчернкивание допускается).
#
#4. Библиотеки добавляются только из пути ${KIPRJMOD}/Libray (вложенные каталокги игнорируются)
#
#5. Для повторного запуска необхдимо удалить бекап главного файла проекта.
#
#
#Работоспособность скрипта проверена на версии Kikad 7 для Ubuntu 18.04, 20.04 и 22.04
#

if ls Libray | grep "\.kicad_sym$" >> /dev/null
then
if name=$(ls | grep "\.kicad_pro.bak$")
then
echo -e "Скрипт уже запускался, сработал правильно и повторного запуска не требует.
Если вы всё же считаете, что требует, удалите файл\033[32m $name\e[0m и запустите скрипт повторно."
else
echo -e "Автор не несёт ответственности за последствия работы скрипта. )))
Скрипт \033[41mсам делает бекапы изменяемых файлов\e[0m, но для наёжности автор рекомендует сохранистья :-)
\033[32mУсловия срабатывания есть в теле скрипта.\e[0m"
echo -n "Продолжить? (y/N) "

read item
case "$item" in
    y|Y)  echo "Поехали"
        ;;
    n|N) echo "До свидания :-("
        exit 0
        ;;
    *) echo "До свидания :-("
        exit 0
        ;;
esac
#Создаем переменные
libray_name=$(basename -s .kicad_sym Libray/*.kicad_sym| sed -e ':a' -e '$!N' -e '$!ba' -e 's/\n/","/g' -e s/^/\"/g -e s/$/\"/g)
libray_mas=$(basename -s .kicad_sym Libray/*.kicad_sym| sed -e ':a' -e '$!N' -e '$!ba' -e 's/\n/ /g')
project_name=$(ls | grep "\.kicad_pro$")
#Создаём массив с именами библиотек
Library=($libray_mas)
#Вычисляем длинну массива Library и добавляем в переменную (перед именем массива  нужно поставить #, а в место значений @ или *)
lib_size=${#Library[*]}
#Проверяем наличие фыйла sym-lib-table
if ls | grep "sym-lib-table"  >> /dev/null
then
echo -e "Файл\033[32m sym-lib-table\e[0m уже существует, добавляем в него библиотеки."
# Проверяем были ли библиотерки из каталога Libray ранее добавлены в проект и все отсутствующие вносим в массив Library2
for (( i=0; i < $lib_size; i++ ))
do
if ! grep -o Libray/${Library[i]} sym-lib-table  >> /dev/null
then
Library_temp[i]=${Library[i]}
#Костыль.
#По непонятной причине при добавлении данных в массив Library_temp[i]=${Library[i]} вот таким способом
#нижеследующая команда sed некоректно обрабатывает последний элемент массива оставляя вывод пустым.
#Скорее всего нехватает какогото скрытого символа. Добавление ещё одного элемента массива не решает проблему,
#в таком случае всё равно элемент, ставший теперь предпоследним, не читается.
#Поэтому массив выводится в переменную как строка которая добавляется в качестве значений в новый массив
libray_mas_temp=$(echo ${Library_temp[*]})
Library2=($libray_mas_temp)
#Конец костыля.
fi
done
lib_size2=${#Library2[*]}
sed -i.bak '' sym-lib-table
for (( i=0; i < $lib_size2; i++ ))
do
sed -i '/(version 7)/ a \  (lib (name "'${Library2[i]}'")(type "KiCad")(uri "${KIPRJMOD}/Libray/'${Library2[i]}'.kicad_sym")(options "")(descr ""))' sym-lib-table
done
libray_name=$(echo ${Library2[*]} | sed -e ':a' -e '$!N' -e '$!ba' -e 's/ /","/g' -e s/^/\"/g -e s/$/\"/g)
else

echo -e "Создаём файл\033[32m sym-lib-table\e[0m и добавляем в него библиотеки."
echo "(sym_lib_table
  (version 7)
)" > sym-lib-table
for (( i=0; i < $lib_size; i++ ))
do
sed -i '/(version 7)/ a \  (lib (name "'${Library[i]}'")(type "KiCad")(uri "${KIPRJMOD}/Libray/'${Library[i]}'.kicad_sym")(options "")(descr ""))' sym-lib-table
done
fi

#делаем бэкап файла *.kicad_pro и меняем данные в файле
name=$(ls | grep "\.kicad_pro$")
echo -e "Добавляем библиотеки в избранное, прописывая их в файл\033[32m $name\e[0m."
sed -i.bak '' $project_name
if ! echo $libray_name | grep -o "\"\"" >> /dev/null
then
jq '. + {libraries:{pinned_footprint_libs: (.libraries.pinned_footprint_libs), pinned_symbol_libs:(.libraries.pinned_symbol_libs + ['$libray_name'])}}' $project_name.bak > $project_name
fi
echo -e "\033[32mА всё :-)\e[0m
Автор благодарит вас за доверие к его поделке. И напоминает, что перед удалением бекапов было бы не плохо проверить проект на работоспособность."
fi
else
echo -e "Каталог\033[32m Libray\e[0m отсутствует либо пуст."
fi
exit

